/*************************************************
 * Copyright (C) 2003, CCNY
 * @Author: Jinzhong Niu
 * @Date: Wed Feb 11 00:04:26 EST 2004
 *************************************************/

import java.util.*;

public class Roster_Impl implements Roster{
	
	
	public Roster_Impl() {
		init();
	}
	
	private void init() {
		list = new Vector();
		
		Student_Impl stud = null;
		for (int i=0; i<DATA.length; i++) {
			stud = new Student_Impl(DATA[i][0], DATA[i][1], DATA[i][2]);
			list.addElement(stud);			
		}
	}
	
	public Student getStudentByLastName(String lastName) {
		
		Student stud = null;
		for (Enumeration e = list.elements() ; e.hasMoreElements() ;) {
            stud = (Student)e.nextElement();
			if (stud.getLastName().equalsIgnoreCase(lastName)) {
				return stud;
			}
		}
		
		return null;
		
	}
	
	public Student getStudentByFirstName(String firstName) {
		
		Student stud = null;
		for (Enumeration e = list.elements() ; e.hasMoreElements() ;) {
            stud = (Student)e.nextElement();
			if (stud.getFirstName().equalsIgnoreCase(firstName)) {
				return stud;
			}
		}
		
		return null;
		
	}
	
	public Student getStudentByID(String id) {
		
		Student stud = null;
		for (Enumeration e = list.elements() ; e.hasMoreElements() ;) {
            stud = (Student)e.nextElement();
			if (stud.getID().equalsIgnoreCase(id)) {
				return stud;
			}
		}
		
		return null;
		
	}
	
	public String toString() {
		String s = "";
		
		Student stud = null;
		for (Enumeration e = list.elements() ; e.hasMoreElements() ;) {
            stud = (Student)e.nextElement();
			s += stud.toString() + "\n";
		}
		
		if (s.length() == 0) {
			s = "Roster: EMPTY\n";
		} else {
			s = "Roster: \n=========================\n" + s;
		}
		
		return s;
	}
	
	
	private Vector list = null;
		
	private static String DATA[][] = {
		{"Afzal,", "Mudassar", "0781"},
		{"Agha", "Ayman", "2239"},
		{"Bah", "Mohamed", "5398"},
		{"Benitez", "Anderson", "0692"},
		{"Borovskiy", "Filipp", "4941"},
		{"Changyu", "Daniel", "0664"},
		{"Chao", "Barbara", "0590"},
		{"Chedere", "Anita", "8032"},
		{"Cho", "Hyunwok", "0050"},
		{"Collado", "Joannie", "2601"},
		{"Cyrus", "Roger", "0784"},
		{"Formoso", "Juan", "4362"},
		{"Gallardo", "Rolando", "7393"},
		{"Giang", "Peter", "2344"},
		{"Grullon", "Betty", "7095"},
		{"Johnson", "Andrea", "0528"},
		{"Kamal", "Golam", "4803"},
		{"Kei", "Marcel", "6953"},
		{"Kim", "Dongmyun", "6470"},
		{"Kleanthous", "Alexandra", "4048"},
		{"McFarlane", "Kiehen", "8808"},
		{"Odedele", "Rassidat", "2863"},
		{"Olivares", "Odoaren", "7632"},
		{"Onwudiwe", "Uchenna", "0049"},
		{"Rosendo", "Ricardo", "8843"},
		{"Shenton", "Robert", "5594"},
		{"Springer", "Francisco", "6635"},
		{"Thomas", "Jiby", "6888"},
		{"Varon", "Alfonso", "1389"},
		{"Vasquez", "Norman", "2042"},
		{"Wozniak", "Irena", "6238"},
		{"Xu", "Lecheng", "4432"},
		{"Yang", "Yong", "8538"}		
	};	
}

