/*************************************************
 * Copyright (C) 2003, CCNY
 * @Author: Jinzhong Niu
 * @Date: Wed Feb 11 00:13:32 EST 2004
 *************************************************/

public class Student_Impl implements Student {
	
	public boolean equals(Student s) {
		if (!isValid() || s == null || !s.isValid()) {
			return false;
		}
		
		return lastName.equalsIgnoreCase(s.getLastName())
			&& firstName.equalsIgnoreCase(s.getFirstName())
			&& id.equalsIgnoreCase(s.getID());
	}
	
	public String toString() {
		if (isValid()) {
			return "<LastName>: " + getLastName() + "\t"
				+ "<FirstName>: " + getFirstName() + "\t"
				+ "<ID>: " + getID();
		} else {
			return "INVALID STUDENT INFORMATION !";
		}
	}
	
	public String getLastName() {
		return lastName;
	}
	
	public String getFirstName() {
		return firstName;
	}
	
	public String getID() {
		return id;
	}
	
	public boolean isValid() {
		return valid;
	}
	
	public int getMagicNumber() {
		if (!isValid()) {
			return -1;
		}
		
		int d0 = getID().charAt(0) - '0';
		int d1 = getID().charAt(1) - '0';
		int d2 = getID().charAt(2) - '0';
		int d3 = getID().charAt(3) - '0';
		
		return Math.min(d0+d2, d1+d3)*2;
	}
	
	public Student_Impl(String lastName, String firstName, String id) {
		this.lastName = lastName;
		this.firstName = firstName;
		this.id = id;
		
		valid = (lastName != null) && (lastName.trim().length() != 0)
			&& (firstName != null) && (firstName.trim().length() != 0)
			&& (id != null) && (id.trim().length() != 0);
	}	
	
	private String lastName;
	private String firstName;
	private String id;
	private boolean valid;
	
}

